Ext.define('DSS.component.TimeReference', {
    extend : 'DSS.component.Base',
    oDatePanel:null,
    oLimitPanel:null,
    oDeltaCylcer:null,
    oDateTypeCylcer :null,
    oControlHour :null,
    oControlMinute:null,
    lblAnzeige:null,
    oLimitType:null,
    oLimitHour:null,
    oLimitMinute:null,
    lblLimitAnzeige:null,
    lblSummary:null,
    nowDawn:null,
    nowDusk:null,
    nowSunset:null,
    nowSunrise:null,
    pnlDiff:null,
    constructor : function (config) {
        

        this.lblSummary = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'(hh:mm)',
            width:600,
            padding: "0 0 7 10"
        });
        this.lblAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'(hh:mm)',
            margin: "0 10 0 0"
        });
        this.lblLimitAnzeige = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            value:'Uhr',
            hidden:true
        });
        this.oDatePanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : config.label,
            labelWidth : 80,
            border : 1,
            margin : '0 0 0 10',
            layout : 'column'
        });
        this.oLimitPanel = Ext.create('Ext.form.FieldContainer', {
            fieldLabel : "&#160;",
            labelSeparator:'',
            labelWidth : 80,
            border : 1,
            layout : 'column',
            padding: "5 0 0 0"
        });

        this.oLimitType = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 10',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-limitNo',
                    text : 'ohne Einschr&auml;nkung'
                },{
                    itemId : 'chk-limitBefore',
                    text : 'jedoch sp&auml;testens um'
                }, {
                    itemId : 'chk-limitAfter',
                    text : 'jedoch fr&uuml;hestens um'
                } ]
            },
            listeners: {
                change: function(btn,item) {
                    btn.up().up().oLimitHour.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitMinute.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().lblLimitAnzeige.setVisible(item.getItemId()!='chk-limitNo');
                    btn.up().up().oLimitHour.setValue(0);
                    btn.up().up().oLimitMinute.setValue(0);
                }
            },
            showText : true,
            width : 150
        });
        this.oLimitHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23,
            hidden:true
        });
        this.oLimitMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59,
            hidden:true      
        });     
        
        this.oDeltaCylcer= Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-before',
                    text : 'fr&uuml;her'
                }, {
                    itemId : 'chk-after',
                    text : 'sp&auml;ter'

                } ]
            },
            showText : true,
            width : 100,
            hidden:true
        });
     
        this.oDateTypeCylcer = Ext.create('Ext.button.Cycle', {
            margin : '0 5 0 0',
            menu : {
                items : [ {
                    checked : true,
                    itemId : 'chk-time',
                    text : 'Uhrzeit'
                }, {
                    itemId : 'chk-sunrise',
                    text : 'Sonnenaufgang'

                } , {
                    itemId : 'chk-sunset',
                    text : 'Sonnenuntergang'

                }, {
                    itemId : 'chk-dawn',
                    text : 'Morgend&auml;mmerung'

                }, {
                    itemId : 'chk-dusk',
                    text : 'Abendd&auml;mmerung'

                } ]
            },
            showText : true,
            width : 150,
            listeners : {
                change : function(btn,item) {
                    var basePanel=this.up().up();
                    if ((basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()=='chk-time')){
                        basePanel.oControlHour.setValue(12);                  
                        basePanel.oControlMinute.setValue(0);                       
                    } 
                    if ((!basePanel.oDeltaCylcer.isVisible()) && (item.getItemId()!='chk-time')){
                        basePanel.oControlHour.setValue(0);                  
                        basePanel.oControlMinute.setValue(0);
                    }
                    basePanel.oDeltaCylcer.setVisible(item.getItemId()!='chk-time');
                    basePanel.oLimitPanel.setVisible(item.getItemId()!='chk-time');
                    basePanel.doLayout();
                    basePanel.updateSummary();
                }
            }
        });
        
        this.oControlHour = Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            width : 43,
            margin : '0 5 0 0',
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 23
        });
        this.oControlMinute = Ext.create('Ext.form.field.Number', {
            width : 43,
            allowBlank : false,
            margin : '0 5 0 0',
            value : 0,
            minValue : 0,
            maxValue : 59      
        });     
        this.pnlDiff = Ext.create('Ext.panel.Panel', {
            heigth : 0,
            border : "1 0 0 0",
            width : "100%",
            padding: "7 0 15 0"
         });
        
        this.oLimitPanel.add(this.oLimitType);
        this.oLimitPanel.add(this.oLimitHour);
        this.oLimitPanel.add(this.oLimitMinute);
        this.oLimitPanel.add(this.lblLimitAnzeige);
        
        this.oDatePanel.add(this.oDateTypeCylcer);
        this.oDatePanel.add(this.oControlHour);
        this.oDatePanel.add(this.oControlMinute);         
        this.oDatePanel.add(this.lblAnzeige);
        
        this.oDatePanel.add(this.oDeltaCylcer);
        
        Ext.apply(this, {           
            items : [this.lblSummary, this.pnlDiff, this.oDatePanel ,this.oLimitPanel]
        });
        var me=this;
        var oReplay=function() {me.updateSummary()};
        
        var oUpdate=function(sString) {me.getDateValues(sString)};
        window.setInterval(oReplay,30*1000);
        me.updateSummary();
        dss.ajaxAssyncRequestWithoutAnswer('/json/property/query',{query:'/config/geodata(sunset,sunrise,civil_dawn,civil_dusk)'},oUpdate)
        this.callParent(arguments);              
    },
    getDateValues:function(sString){
        var result = Ext.JSON.decode(sString);
        if (result.ok) {
            this.nowDawn=result.result.geodata[0].civil_dawn;
            this.nowDusk=result.result.geodata[0].civil_dusk;
            this.nowSunrise=result.result.geodata[0].sunrise;
            this.nowSunset=result.result.geodata[0].sunset;
        }
    },
    updateSummary:function(){
        var oNow=new Date();
        var sText="Aktuelle Uhrzeit: " + Ext.Date.format(oNow, "H:i");

        switch (this.oDateTypeCylcer.getActiveItem().getItemId()) {
            case 'chk-sunrise':
                sText+=" Sonnenaufgang heute: " + this.nowSunrise;
                break;
            case 'chk-sunset':
                sText+=" Sonnenuntergang heute: " + this.nowSunset;
                break;
            case 'chk-dawn':
                sText+=" Morgend&auml;mmerung heute: " + this.nowDawn;
                break;
            case 'chk-dusk':
                sText+=" Abendd&auml;mmerung heute: " + this.nowDusk;
                break;
        }
        this.lblSummary.setValue(sText);
    },
    reset:function(){
        this.oDateTypeCylcer.setActiveItem('chk-time');
        this.oLimitType.setActiveItem('chk-limitNo');
        this.oDeltaCylcer.setActiveItem('chk-after');
        this.oControlHour.setValue(12);                  
        this.oControlMinute.setValue(0);
        this.oLimitHour.setValue(0);
        this.oLimitMinute.setValue(0);
    },
    setValue:function (value) {
        var sec = Math.abs(value.offset%60);
        var min = Math.abs(Math.floor(value.offset / 60) % 60);
        var hou = Math.abs(Math.floor(value.offset / 3600));
        if (value.offset<0)
            this.oDeltaCylcer.setActiveItem('chk-before');
        else
            this.oDeltaCylcer.setActiveItem('chk-after');     
        switch (value.timeBase)
        {
            case 'daily':
                this.oDateTypeCylcer.setActiveItem('chk-time');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'sunset':
                this.oDateTypeCylcer.setActiveItem('chk-sunset');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);          
            break;
            case 'sunrise':
                this.oDateTypeCylcer.setActiveItem('chk-sunrise');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'dusk':
                this.oDateTypeCylcer.setActiveItem('chk-dusk');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
            case 'dawn':
                this.oDateTypeCylcer.setActiveItem('chk-dawn');
                this.oControlMinute.setValue(min);
                this.oControlHour.setValue(hou);                  
            break;
        }

        if (value.limitAfter!=null)
        {
            this.oLimitType.setActiveItem('chk-limitAfter');
            var secLimit = Math.abs(value.limitAfter%60);
            var minLimit = Math.abs(Math.floor(value.limitAfter / 60) % 60);
            var houLimit = Math.abs(Math.floor(value.limitAfter / 3600));
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else if (value.limitBefore!=null)
        {
            this.oLimitType.setActiveItem('chk-limitBefore');
            var secLimit = Math.abs(value.limitBefore%60);
            var minLimit = Math.abs(Math.floor(value.limitBefore / 60) % 60);
            var houLimit = Math.abs(Math.floor(value.limitBefore / 3600));
            this.oLimitMinute.setValue(minLimit);
            this.oLimitHour.setValue(houLimit);
        } else {
            this.oLimitType.setActiveItem('chk-limitNo');
        }
    },
    isValid: function () {
        return true;
    },
    getValue: function () {
        var oValue={};
        oValue.offset=this.oControlHour.getValue()*3600;
        oValue.offset+=this.oControlMinute.getValue()*60;
        var sDate=this.oDateTypeCylcer.getActiveItem().getItemId();
        switch(sDate)
        {
            case 'chk-time':
                oValue.timeBase='daily';
                break;
            case 'chk-sunset':
                oValue.timeBase='sunset';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-sunrise':
                oValue.timeBase='sunrise';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dusk':
                oValue.timeBase='dusk';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
            case 'chk-dawn':
                oValue.timeBase='dawn';
                if (this.oDeltaCylcer.getActiveItem().getItemId()=='chk-before')
                    oValue.offset*=-1;
                break;
        }
        if (this.oLimitType.getActiveItem().getItemId()=='chk-limitAfter') {
            oValue.limitAfter=this.oLimitMinute.getValue()*60;
            oValue.limitAfter+=this.oLimitHour.getValue()*3600;
        } else if (this.oLimitType.getActiveItem().getItemId()=='chk-limitBefore') {
            oValue.limitBefore=this.oLimitMinute.getValue()*60;
            oValue.limitBefore+=this.oLimitHour.getValue()*3600;
        }
        return oValue;
    }
});